
proc WindowProc,hwnd,wmsg,wparam,lparam
	push	ebx esi edi
	cmp	[wmsg],WM_TIMER
	je	wmtimer
	cmp	[wmsg],WM_GETMINMAXINFO
	je	wmgetminmaxinfo
	cmp	[wmsg],WM_SIZE
	je	wmsize
	cmp	[wmsg],WM_CREATE
	je	wmcreate
	cmp	[wmsg],WM_CTLCOLORSTATIC
	je	wmctlcolor
	cmp	[wmsg],RB_LOADING
	je	wmloadfromrefer
	cmp	[wmsg],RB_KILLTICK
	je	wmkilltick
	cmp	[wmsg],WM_DESTROY
	je	wmdestroy
	invoke	DefWindowProc,[hwnd],[wmsg],[wparam],[lparam]
	jmp	finish

  wmtimer:
	stdcall TransFormLoadString,flag.slesh
	invoke	SendMessage,dword[hprogress],PBM_STEPIT,1,0
     ;   cmp     eax, 100
     ;   jne     finish
     ;   invoke  SendMessage,[hwnd],RB_KILLTICK,0,0
	jmp	finish

  wmcreate:
	invoke	GetClientRect,[hwnd], rc
	sub	[rc.bottom], 24
	sub	[rc.right], 40
      controls:
	invoke	CreateWindowEx,0,class.progress,0,WS_CHILD+WS_VISIBLE+WS_BORDER,\
			       20,[rc.bottom],[rc.right],20,[hwnd],0,[hinstance],0
	mov	dword[hprogress], eax
	sub	[rc.bottom], 24
	invoke	CreateWindowEx,0,class.static,text.load,WS_CHILD+WS_VISIBLE,\
			       20,[rc.bottom],200,20,[hwnd],0,[hinstance],0
	mov	dword[hprogress+4], eax
	invoke	SetWindowLong,eax,GWL_WNDPROC,LabelProc
	mov	dword[hprogress+8], eax
	stdcall CreateListView,[hwnd]
	invoke	ShowWindow,[hlist],FALSE
      timer:
	invoke	SetTimer,[hwnd],ID_TIMER, 30, 0
      findbox:
	invoke	GetClientRect,[hwnd], rc
	sub	[rc.bottom], 60
	sub	[rc.right], 8
	invoke	SendMessage, [hwnd], WM_GETFONT, 0, 0
	invoke	GetObject, eax, sizeof.LOGFONT, lf
	invoke	CreateFontIndirect, lf
	mov	[hfont], eax
	invoke	CreateWindowEx,0,class.button,text.find,WS_CHILD+WS_VISIBLE+BS_GROUPBOX+BS_FLAT,\
			       4,[rc.bottom],[rc.right],58,[hwnd],0,[hinstance],0
	mov	dword[hbox], eax
	invoke	SendMessage,eax,WM_SETFONT,[hfont],TRUE
	invoke	SetWindowLong,dword[hbox],GWL_WNDPROC,BoxProc
	mov	dword[hbox+8], eax

	invoke	GetClientRect,[hwnd], rc
	sub	[rc.right], 96
	invoke	CreateWindowEx,0,class.button,text.find,WS_CHILD+WS_VISIBLE+BS_FLAT,\
			       [rc.right],22,80,22,dword[hbox],ID_FIND,[hinstance],0
	mov	dword[hfind], eax
	invoke	SendMessage,eax,WM_SETFONT,[hfont],TRUE
	sub	[rc.right], 4
	invoke	CreateWindowEx,0,class.edit,0,WS_CHILD+WS_VISIBLE+WS_BORDER,\
			       4,22,[rc.right],22,dword[hbox],0,[hinstance],0
	mov	dword[hfind+4], eax
	invoke	SendMessage,eax,WM_SETFONT,[hfont],TRUE
	invoke	ShowWindow,dword[hbox],FALSE
      open_data:
	invoke	SendMessage,[hwnd],RB_LOADING,0,0
	jmp	finish

  wmctlcolor:
	invoke	SendMessage,[lparam],[wmsg],[wparam],[lparam]
	jmp	finish

  wmgetminmaxinfo:
	mov	ebx,[lparam]
	virtual at ebx
	mmi	MINMAXINFO
	end	virtual
	mov	[mmi.ptMinTrackSize.x],550
	mov	[mmi.ptMinTrackSize.y],400
	jmp	finish

  wmsize:
	cmp	[flag.loading], TRUE
	je	loadsize
	invoke	GetClientRect,[hwnd], rc
	sub	[rc.bottom], 68
	sub	[rc.right], 8
	invoke	MoveWindow,[hlist],4,4,[rc.right],[rc.bottom],TRUE
	add	[rc.bottom], 8
	invoke	MoveWindow,dword[hbox],4,[rc.bottom],[rc.right],58,TRUE
	sub	[rc.right], 88
	invoke	MoveWindow,dword[hfind+0],[rc.right],22,80,22,TRUE
	sub	[rc.right], 4
	invoke	MoveWindow,dword[hfind+4],4,22,[rc.right],22,dword[hbox],TRUE
	jmp	finish
      loadsize:
	invoke	GetClientRect,[hwnd], rc
	sub	[rc.right], 40
	shr	[rc.bottom], 1
	invoke	MoveWindow,dword[hprogress],20,[rc.bottom],[rc.right],20,TRUE
	sub	[rc.bottom], 24
	invoke	MoveWindow,dword[hprogress+4],20,[rc.bottom],200,20,TRUE
	jmp	finish

  wmloadfromrefer:
	invoke	CreateThread,0,0,ThreadFunc,0,0,0    ;   !!!
	mov	[hthread], eax
	jmp	finish

  wmkilltick:
	mov	[flag.loading], FALSE
	invoke	KillTimer, [hwnd], ID_TIMER
	invoke	ShowWindow,[hlist],TRUE
	invoke	ShowWindow,dword[hbox],TRUE
	invoke	DestroyWindow,dword[hprogress]
	invoke	DestroyWindow,dword[hprogress+4]
	invoke	SendMessage,[hwnd],WM_SIZE,0,0
	invoke	CloseHandle,[hthread]
	jmp	finish

  wmdestroy:
	invoke	PostQuitMessage,0
	xor	eax,eax
  finish:
	pop	edi esi ebx
	ret
endp