
proc FindItem str, sts
     local item:DWORD
     local count:DWORD

	mov	eax, [hf.count]
	mov	[count], eax
	mov	[item], 0
      .loop_scan:
	stdcall ScanItem,[hlist],[item],[str]
	cmp	eax, FALSE
	je	.next_item
	stdcall SelectItem,[hlist],[item]
	ret
      .next_item:
	inc	[item]
	mov	eax,[count]
	dec	eax
	cmp	eax, -1
	jne	.loop_scan
      .error_find:
	invoke	MessageBeep, 0
	ret
endp

proc SelectItem hList, iItem

	invoke	SetFocus, [hList]
	mov	[lvi.state], -1
	mov	[lvi.stateMask], LVIS_FOCUSED + LVIS_SELECTED;  
	invoke	SendMessage, [hList], LVM_SETITEMSTATE, [iItem], lvi	 ; iSubItem     
     ;   invoke  SendMessage, [hList], LVM_ENSUREVISIBLE, [iItem], 0
	ret
endp

proc ScanItem hList, iItem, String

	mov	[lvi.mask], LVIF_TEXT
	mov	[lvi.iSubItem], 0
      .loop_find:
	mov	eax, [iItem]
	mov	[lvi.iItem], eax
	lea	eax, [string_buffer]
	mov	[lvi.pszText], eax
	mov	[lvi.cchTextMax],260
	lea	eax, [lvi]
	invoke	SendMessage,[hList],LVM_GETITEMTEXT,[iItem], eax
	invoke	lstrcmp,[String],string_buffer
	inc	[lvi.iSubItem]
	mov	ecx, [lvi.iSubItem]
	cmp	ecx, 6
	je	.end_loop
	cmp	eax, 0
	jne	.true
      .end_loop:
	mov	eax, FALSE
	ret
      .true:
	mov	eax, TRUE
	ret
endp

