proc OpenReferBook

	invoke	GetModuleFileName,0,string_buffer,512h
	stdcall ExtractFilePath,string_buffer,string_buffer
	cinvoke wsprintf, path_buffer, book.file,string_buffer
	invoke	_lopen,path_buffer, OF_READ
	mov	[hfile], eax
	ret
endp

proc ReadReferBookHeader

	invoke _lread, [hfile], hf, sizeof.HEAD_FILE
	ret
endp

proc ReadReferBookItem
	invoke _lread, [hfile], pi, sizeof.PHONE_ITEM
	ret
endp

proc CloseReferBook
	invoke	CloseHandle, [hfile]
	ret
endp

proc LoadingList parent
     local int:DWORD

	call	InitListView
	call	OpenReferBook
	call	ReadReferBookHeader
	mov	eax, dword[text.sign]
	cmp	eax, [hf.sign]
	jne	error_read
	mov	eax, [hf.count]
	mov	[int], eax
     loop_read:
	call	ReadReferBookItem
	call	FillListItem
	dec	[int]
	cmp	[int], -1
	jne	loop_read
	call	CloseReferBook
	invoke	SendMessage,[parent],RB_KILLTICK,0,0
	ret
     error_read:
	invoke	MessageBox,[parent],TException.load,0,MB_ICONERROR
	invoke	SendMessage,[parent],WM_DESTROY,0,0
	ret
endp

proc InitListView
	mov	[lvi.mask], LVIF_TEXT
	mov	[lvi.iSubItem], 0
	mov	[lvi.iItem], 0
	mov	[lvi.lParam], 0
	ret
endp

proc FillListItem

	lea	eax, [pi.name.last]
	mov	[lvi.pszText], eax
	invoke	SendMessage,[hlist],LVM_INSERTITEM,0,lvi

	test	eax, eax
	lea	eax, [pi.name.first]
	mov	[lvi.pszText], eax
	inc	[lvi.iSubItem]
	invoke	SendMessage,[hlist],LVM_SETITEM,0,lvi

	test	eax, eax
	lea	eax, [pi.name.patronymic]
	mov	[lvi.pszText], eax
	inc	[lvi.iSubItem]
	invoke	SendMessage,[hlist],LVM_SETITEM,0,lvi

	test	eax, eax
	lea	eax, [pi.street]
	mov	[lvi.pszText], eax
	inc	[lvi.iSubItem]
	invoke	SendMessage,[hlist],LVM_SETITEM,0,lvi

	test	eax, eax
	lea	eax, [pi.home]
	mov	[lvi.pszText], eax
	inc	[lvi.iSubItem]
	invoke	SendMessage,[hlist],LVM_SETITEM,0,lvi

	test	eax, eax
	lea	eax, [pi.phone]
	mov	[lvi.pszText], eax
	inc	[lvi.iSubItem]
	invoke	SendMessage,[hlist],LVM_SETITEM,0,lvi


	inc	[lvi.iItem]
	sub	[lvi.iSubItem], 5
      ;  lea     eax, [pi.phone]
      ;  mov     [lvi.pszText], eax
      ;  invoke  SendMessage,[hlist],LVM_INSERTITEM,0,lvi
      ;  test    eax, eax
      ;  lea     eax, [pi.home]
      ;  mov     [lvi.pszText], eax
      ;  inc     [lvi.iSubItem]
      ;  invoke  SendMessage,[hlist],LVM_SETITEM,0,lvi

	ret
endp
