proc ScanDecimalStr buffer

	push	   eax
	push	   esi
	pushf
	cld
	mov	   esi, [buffer]
	xor	   ecx, ecx
      local
      .str_find_decimal:
	lodsb
	cmp	   al, '\'
	je	   .ok_separator
	cmp	   al, '/'
	je	   .ok_separator
	cmp	   al, 0
	je	   .end_find
	jmp	   .str_find_decimal
      local
      .ok_separator:
	inc	   ecx
	jmp	   .str_find_decimal
      local
      .end_find:
	popf
	pop	   esi
	pop	   eax
	ret
endp

proc ExtractFilePath buffer, path
	push	   eax
	push	   ecx
	push	   esi
	push	   edi
	pushf
	stdcall    ScanDecimalStr, [path]
      local
      extract_of_str:
	cld
	mov	   esi, [path]
	mov	   edi, [buffer]
      local
      extract_path:
	lodsb
	cmp	   al, '\'
	je	   dec_str
	cmp	   al, '/'
	je	   dec_str
	cmp	   ecx, 0
	je	   end_of_str
	stosb
	jmp	   extract_path
      local
      dec_str:
	stosb
	sub	   ecx, 1
	jmp	   extract_path
      local
      end_of_str:
	mov	   al, 0
	stosb
	popf
	pop	   edi
	pop	   esi
	pop	   ecx
	pop	   eax
	ret
endp