
section '.idata' import data readable writeable

macro import lib,[functions]
{ common macro import_#lib \{ import lib,functions \} }

macro api [functions]
{ common macro all_api \{ all_api
			  api functions \} }
macro all_api {}

include '..\..\include\api/kernel32.inc'
include '..\..\include\api/user32.inc'
include '..\..\include\api/gdi32.inc'
include '..\..\include\api/advapi32.inc'
include '..\..\include\api/comctl32.inc'
include '..\..\include\api/comdlg32.inc'
include '..\..\include\api/shell32.inc'
include '..\..\include\api/wsock32.inc'

purge import,api

     library kernel32,'KERNEL32.DLL',\
	     user32,'USER32.DLL',\
	     gdi32,'GDI32.DLL',\
	     advapi32,'ADVAPI32.DLL',\
	     comctl32,'COMCTL32.DLL',\
	     comdlg32,'COMDLG32.DLL',\
	     shell32,'SHELL32.DLL',\
	     wsock32,'WSOCK32.DLL'
     import_kernel32
     import_user32
     import_gdi32
     import_advapi32
     import_comctl32
     import_comdlg32
     import_shell32
     import_wsock32

     all_api